.\"     $NetBSD: wi.4,v 1.36 2005/07/06 07:30:59 dyoung Exp $
.\"
.\" Copyright (c) 1997, 1998, 1999
.\"	Bill Paul <wpaul@ctr.columbia.edu>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"	$Id: wi.4,v 1.37 2005/07/06 07:47:45 wiz Exp $
.\"
.Dd July 6, 2005
.Dt WI 4
.Os
.Sh NAME
.Nm wi
.Nd
WaveLAN/IEEE and PRISM-II 802.11 wireless network driver
.Sh SYNOPSIS
.Cd "wi* at pcmcia? function ?"
.Cd "wi* at pci? dev ? function ?"
.Sh DESCRIPTION
The
.Nm
driver provides support for Lucent Technologies WaveLAN/IEEE PCCARD adapters
(also known as WaveLAN II cards) and various PCI/MiniPCI/PCCARD adapters which use
Intersil PRISM-II and PRISM-2.5 chipsets.
Note that while Lucent sells both ISA and PCMCIA WaveLAN/IEEE devices,
the ISA product is actually a PCMCIA card in an ISA to PCMCIA bridge adapter.
Consequently, the
.Nm
driver is required for both the ISA and PCMCIA NICs.
Also note that some of the PRISM-II adapters works only at 3.3V, hence
.Xr cardbus 4
support is required for those cards to set VCC correctly,
even though they are 16-bit cards.
.Pp
The core of the WaveLAN/IEEE is the Lucent Hermes controller.
All host/device interaction is via programmed I/O with the Hermes.
The Hermes supports 802.11 and 802.3 frames, power management, BSS, WDS
and ad-hoc operation modes.  The Silver and the Gold cards of the
WaveLAN/IEEE also support WEP.  Unlike the other IEEE 802.11 network cards,
the WaveLAN Gold cards accept 104 bits key (13 characters) for WEP
encryption.  The Intersil PRISM-II controller supports WEP as well.
.Pp
The
.Nm
driver encapsulates all traffic as 802.11 frames, however
it can receive either 802.11 or 802.3 frames.
Transmit speed is selectable between 1Mbps fixed,
2Mbps fixed or 2Mbps with auto fallback.
For WaveLAN/IEEE Turbo adapters, speeds up to 6Mbps are available.
For WaveLAN/IEEE Turbo 11Mbps adapters and PRISM-II adapters, speeds up to
11Mbps are available.
.Pp
The
.Nm
driver supports configuration of Lucent cards for special ad-hoc operation.
In this mode, the nwid is ignored and stations can communicate among each
other without the aid of an access point.  Note that this mode is specific
to Lucent chips, and not in the IEEE 802.11 specification.  Due to changes
in the implementation of this special ad-hoc mode, Lucent-based cards with
different firmware revisions may not interoperate in this mode.  This mode
is no longer the default and must be selected using the
.Xr ifconfig 8
.Pq media option Dq adhoc,flag0
utility.
.Pp
Recent versions of Lucent and PRISM-II firmware support IBSS creation.
IBSS is the standard IEEE 802.11 ad-hoc mode.  In this mode, the nwid
should be specified.  At least one node must be able to create IBSS.
The IBSS mode is enabled by
.Dq adhoc
or
.Dq ibss
media option.
IBSS creation is automatically enabled if supported.
.Pp
The
.Nm
driver defaults to infrastructure mode (i.e., using an access point).
.Pp
Recent versions of PRISM-II firmware support operating as an 802.11
Access Point.  In this mode, the Access Point station should set the
nwid.  This will create a standard 802.11 network, and the Access Point
station will show up in an Access Point scan.  This mode is enabled
using the
.Dq hostap
media option.
.Pp
For more information on configuring this device, see
.Xr ifconfig 8
and
.Xr ifmedia 4 .
.Sh HARDWARE
Cards supported by the
.Nm
driver include:
.Pp
.Bl -item -offset indent -compact
.It
Alvarion BreezeNET
.It
Lucent WaveLAN/IEEE 2.0Mb Bronze
.It
Lucent WaveLAN/IEEE 2.0Mb Silver
.It
Lucent WaveLAN/IEEE Turbo
.It
Lucent WaveLAN/IEEE Turbo 11Mbps
.It
Melco AIR CONNECT WLI-PCM-L11, WLI-PCM-L11G
.It
Melco AIR CONNECT WLI-CF-S11G
.It
Compaq WL100 11Mbps Wireless
.It
Corega Wireless LAN PCC-11, PCCA_11, PCCB_11
.It
DEC/Cabletron RoamAbout 802.11 DS High Rate
.It
D-Link DWL-520 11Mbps PCI Card, Revs. A1,A2,B1,B2
.It
D-Link DWL-520 11Mbps PCI Card, Rev. C1
.Em not supported ,
see
.Xr atw 4
.It
D-Link DWL-520 11Mbps PCI Card, Rev. D
.Em not supported ,
see
.Xr rtw 4
.It
D-Link DWL-650 11Mbps WLAN Card
.It
D-Link DWL-650 11Mbps WLAN Card, Rev. P
.Em not supported
(Prism 3 chipset)
.It
D-Link DCF-650W CF Card
.It
ELECOM Air@Hawk LD-WL11
.It
ELSA AirLancer MC-11
.It
Ericsson Wireless LAN
.It
Farallon Skyline 11Mbps Wireless
.It
Intel PRO/Wireless 2011 LAN PC Card
.It
ICOM SL-1100
.It
IO-DATA WN-B11/PCM
.It
Intersil PRISM Mini-PCI
.It
Linksys Group, Inc. Instant Wireless Network PC Card, CF Card
.It
Linksys Group, Inc. Instant Wireless Network WMP11 PCI Card
.It
Linksys Group, Inc. Instant Wireless Network WMP11v4 PCI Card
.Em not supported
.It
NCR WaveLAN/IEEE
.It
NEC Wireless Card CMZ-RT-WP, PK-WL001, PC-WL/11C
.It
PLANEX GeoWave/GW-NS110
.It
Symbol Spectrum24 Wireless Networker PC Card, CF Card
.It
TDK LAK-CD011WL
.It
SMC EZ Connect 11M Wireless CF Card SMC2642W
.It
SMC EliteConnect Wireless Adapter PC Card SMC2531W-B
.It
Z-Com XI-626 PCI Card
.El
.Pp
The original PRISM-I chipset is supported by the
.Xr awi 4
driver.
.Sh DIAGNOSTICS
.Bl -diag
.It "wi%d: init failed"
The WaveLAN failed to come ready after an initialization command was
issued.
.It "wi%d: failed to allocate %d bytes on NIC"
The driver was unable to allocate memory for transmit frames in the
NIC's on-board RAM.
.It "wi%d: device timeout"
The WaveLAN failed to generate an interrupt to acknowledge a transmit
command.
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr pcmcia 4 ,
.Xr ifconfig 8 ,
.Xr wiconfig 8
.Rs
.%T HCF Light programming specification
.%O http://www.wavelan.com
.Re
.Sh HISTORY
The
.Nm
device driver first appeared in
.Nx 1.5 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@ctr.columbia.edu .
.Sh BUGS
The execution of
.Xr wiconfig 8
while the interface is down can produce some error messages.
